%%
% Funo de aproximao de integrao numrica que devolve os pontos de
% integrao e pesos dado o nmero de pontos pretendido. Estes valores
% esto disponveis numa tabela apresentada na aula.

function [x,w] = GaussLegendre1D(n)
x = [];
w = [];
switch n
    case 1
        x = 0;
        w = 2;
    case 2
        x = [sqrt(1/3) -sqrt(1/3)];
        w = [1 1];
    case 3
        x = [0 sqrt(3/5) -sqrt(3/5)];
        w = [8/9 5/9 5/9];
    case 4
        x = [sqrt(3/7 - 2/7 *sqrt(6/5)), -sqrt(3/7 - 2/7 *sqrt(6/5)) ...
            sqrt(3/7 + 2/7 *sqrt(6/5)), -sqrt(3/7 + 2/7 *sqrt(6/5))];
        w = [(18 +sqrt(30))/36 ,(18 +sqrt(30))/36 ,(18 - sqrt(30))/36 ...
            (18 - sqrt(30))/36];
end
end