function [x,w] = GaussLegendre2D(n)

switch n
    case 2
        points = [sqrt(1/3), -sqrt(1/3)];
        weights = [1, 1];
    case 3
        points = [0,sqrt(3/5),-sqrt(3/5)];
        weights = [8/9, 5/9, 5/9];
    case 4
       points = [sqrt(3/7 - 2/7 *sqrt(6/5)), -sqrt(3/7 - 2/7 *sqrt(6/5)) ...
           sqrt(3/7 + 2/7 *sqrt(6/5)), -sqrt(3/7 + 2/7 *sqrt(6/5))];
       weights = [(18 +sqrt(30))/36 ,(18 +sqrt(30))/36 ,(18 - sqrt(30))/36 ...
           (18 - sqrt(30))/36];
end
x = zeros(length(points),2);
w = zeros(length(weights),1);
L = 1;
for i = 1:length(points)
    for j = 1:length(weights)
        x(L,1) = points(i);
        x(L,2) = points(j);
        w(L) = weights(i)*weights(j);
        L = L + 1;
    end
end
