clear all
close all
clc
%-----------------------------------------------------------------------------
%       Tarefa 64 : Refinar uma malha de T3 dividindo os elementos em 4
%-----------------------------------------------------------------------------
NL=3;	%	numero de niveis pretendido
x=[1 0 0 0.707107 0 0.5]';
y=[0 1 0 0.707107 0.5 0]';
TRI=[1 4 6;2 5 4;3 6 5;4 5 6];

figure(1)
Nelt=size(TRI,1);
for i=1: Nelt
    no1=TRI(i,1);
    no2=TRI(i,2);
    no3=TRI(i,3);
    edofs=[no1 no2 no3];
    %polyshape (x(edofs)',y(edofs)');hold
    fill (x(edofs),y(edofs),'y');hold on
    plot(x(edofs),y(edofs),'b');hold on
end
plot(x,y,'ro');

%   varios niveis de refinamento
for Nr=1: NL
    Nelt=size(TRI,1);
    Nnds=size(x,1);
    Nels=Nelt;
    Nfron = Nnds  ;  % freeze number of nodes for later use
    for i=1: Nelt
        no1=TRI(i,1);
        no2=TRI(i,2);
        no3=TRI(i,3);
        % cria novos pontos no lado 1-2
        Nnds= Nnds + 1;
        x(Nnds)=(x(no1)+x(no2))/2;
        y(Nnds)=(y(no1)+y(no2))/2;
        no4 = Nnds;
        % cria novos pontos no lado 2-3
        Nnds= Nnds + 1;
        x(Nnds)=(x(no3)+x(no2))/2;
        y(Nnds)=(y(no3)+y(no2))/2;
        no5 = Nnds;
        % cria novos pontos no lado 3-1
        Nnds= Nnds + 1;
        x(Nnds)=(x(no3)+x(no1))/2;
        y(Nnds)=(y(no3)+y(no1))/2;
        no6 = Nnds;
        Nnds =size(x,1);        % numero de nos dos TRI gerados
        %----------- corrigir a posicao dos nos da fronteira aqui -----------------
        %            para assegurar ter o raio exactamente r=1
        kount=0;
        for k=1:Nnds
            xx=x(k);
            yy=y(k);
            % calcular o raio
            r =sqrt(xx^2+yy^2);
            if (r > 0.9+0.18*(Nr-1))  % seleccao dos nos da fronteira feita pelo valor do raio
                %   este no esta na fronteira
                %   corrigir as coordenadas para ter o raio exactamente r=1
                kount=kount+1;
                x(k)=xx/r;
                y(k)=yy/r;
            end
        end
        %   actualize a lista de TRI
        TRI(i,1)=no1;
        TRI(i,2)=no4;
        TRI(i,3)=no6;
        %   actualize com novos TRI
        Nels=Nels+1;
        TRI(Nels,1)=no4;
        TRI(Nels,2)=no2;
        TRI(Nels,3)=no5;
        Nels=Nels+1;
        TRI(Nels,1)=no3;
        TRI(Nels,2)=no6;
        TRI(Nels,3)=no5;
        Nels=Nels+1;
        TRI(Nels,1)=no4;
        TRI(Nels,2)=no5;
        TRI(Nels,3)=no6;
    end
    %--------------------------------------------------------------------------
    %       eliminar nos duplos
    %--------------------------------------------------------------------------
    [B C status]=unique([x y],'rows','stable');
    x=B(:,1);
    y=B(:,2);
    Nnds=size(x,1);
    %--------------------------------------------------------------------------
    %       fim de eliminar nos duplos
    %--------------------------------------------------------------------------
    %
    Nelt=size(TRI,1);
    
    for i=1: Nelt
        no1=TRI(i,1);
        no2=TRI(i,2);
        no3=TRI(i,3);
        %   actualize a lista de quads
        TRI(i,1)=status(no1);
        TRI(i,2)=status(no2);
        TRI(i,3)=status(no3);
    end
    
    figure
    Nelt=size(TRI,1);
    for i=1: Nelt
        no1=TRI(i,1);
        no2=TRI(i,2);
        no3=TRI(i,3);
        edofs=[no1 no2 no3];
        %polyshape (x(edofs)',y(edofs)');hold
        fill (x(edofs),y(edofs),'y');hold on
        plot(x(edofs),y(edofs),'b');hold on
    end
    plot(x,y,'ro');
    
end  %  level