clear all
%-----------------------------------------------------------
%       Tarefa 72 : Converter uma malha de Q4 numa de Q9 
%-----------------------------------------------------------
 x=[1 0.7071 0 0.5 0.35 0 0]'
 y=[0 0.7071 1 0 0.35 0.5 0]'
 quad=[7 4 5 6;4 1 2 5;6 5 2 3]

Nquads=size(quad,1)
Nnds=size(x,1)
figure(1)
for i=1:Nquads
edofs=[quad(i,:)]
%polyshape (x(edofs)',y(edofs)');hold
fill (x(edofs),y(edofs),'g');hold on
plot(x(edofs),y(edofs),'b');hold on
end
plot(x,y,'ro');
Nels=Nquads
Nfron = Nnds    % freeze number of nodes for later use
for i=1: Nquads
no1=quad(i,1)
no2=quad(i,2)
no3=quad(i,3)
no4=quad(i,4) 
    % cria novo ponto no lado 1-2
    Nnds= Nnds + 1
    x(Nnds)=(x(no1)+x(no2))/2
    y(Nnds)=(y(no1)+y(no2))/2
    no5 = Nnds
    % cria novo ponto no lado 2-3
    Nnds= Nnds + 1
    x(Nnds)=(x(no3)+x(no2))/2
    y(Nnds)=(y(no3)+y(no2))/2
    no6 = Nnds
    % cria novo ponto no lado 3-4
    Nnds= Nnds + 1
    x(Nnds)=(x(no3)+x(no4))/2
    y(Nnds)=(y(no3)+y(no4))/2
    no7 = Nnds
    % cria novo ponto no lado 4-1
    Nnds= Nnds + 1
    x(Nnds)=(x(no4)+x(no1))/2
    y(Nnds)=(y(no4)+y(no1))/2
    no8 = Nnds
        % cria novo ponto no centro
    Nnds= Nnds + 1
    x(Nnds)=(x(no4)+x(no3)+x(no2)+x(no1))/4
    y(Nnds)=(y(no4)+y(no3)+y(no2)+y(no1))/4
    no9 = Nnds
    %----------- corrigir a posicao dos nos da fronteira aqui -------------
%            para assegurar ter o raio exactamente r=1
kount=0
for k=1:Nnds
    xx=x(k);
    yy=y(k);
    % calcular o raio
    r =sqrt(xx^2+yy^2);
    if (r > 0.92)  % seleccao dos nos da fronteira feita pelo valor do raio
        %   este no esta na fronteira
        %   corrigir as coordenadas para ter o raio exactamente r=1
        kount=kount+1;
        x(k)=xx/r;
        y(k)=yy/r;
    end
end
    %   actualize a lista de quads
    quad9(i,1)=no1
    quad9(i,2)=no2
    quad9(i,3)=no3
    quad9(i,4)=no4
    quad9(i,5)=no5
    quad9(i,6)=no6
    quad9(i,7)=no7
    quad9(i,8)=no8
    quad9(i,9)=no9
end
%--------------------------------------------------------------------------
%       eliminar nos duplos
%--------------------------------------------------------------------------
[B C status]=unique([x y],'rows','stable');
x=B(:,1);
y=B(:,2);
Nnds=size(x,1);
%--------------------------------------------------------------------------
%       fim de eliminar nos duplos
%--------------------------------------------------------------------------

Nels=size(quad9,1)

for i=1: Nels
no1=quad9(i,1)
no2=quad9(i,2)
no3=quad9(i,3)
no4=quad9(i,4)
no5=quad9(i,5)
no6=quad9(i,6)
no7=quad9(i,7)
no8=quad9(i,8)
no9=quad9(i,9)
 %   actualize a lista de quads
    quad9(i,1)=status(no1)
    quad9(i,2)=status(no2)
    quad9(i,3)=status(no3)
    quad9(i,4)=status(no4)
    quad9(i,5)=status(no5)
    quad9(i,6)=status(no6)
    quad9(i,7)=status(no7)
    quad9(i,8)=status(no8)
    quad9(i,9)=status(no9)
end
figure
Nels=size(quad9,1)
for i=1:Nels
no1=quad9(i,1)
no2=quad9(i,2)
no3=quad9(i,3)
no4=quad9(i,4)
no5=quad9(i,5)
no6=quad9(i,6)
no7=quad9(i,7)
no8=quad9(i,8)
no9=quad9(i,9)
edofs=[no1 no5 no2 no6 no3 no7 no4 no8]
%polyshape (x(edofs)',y(edofs)');hold
fill (x(edofs),y(edofs),'y');hold on
plot(x(edofs),y(edofs),'b');hold on
end
plot(x,y,'ro');