function [B, J, psi] = calculoBQuad9 (points,xi,eta)


% Funes de forma.
psi(1) = xi*(1-xi)*eta*(1-eta)/4;
psi(2) = xi*(1+xi)*eta*(eta-1)/4;
psi(3) = xi*(1+xi)*eta*(1+eta)/4;
psi(4) = xi*(xi-1)*eta*(1+eta)/4;
psi(5) = (1-xi*xi)*eta*(eta-1)/2;
psi(6) = xi*(1+xi)*(1-eta*eta)/2;
psi(7) = (1-xi*xi)*eta*(1+eta)/2;
psi(8) = xi*(xi-1)*(1-eta*eta)/2;
psi(9) = (1-xi*xi)*(1-eta*eta);

% Derivadas parciais para as funes de forma.
dPsi(1,1) = (2*xi-1)*eta*(eta-1)/4;
dPsi(2,1) = (2*xi+1)*eta*(eta-1)/4;
dPsi(3,1) = (2*xi+1)*eta*(1+eta)/4;
dPsi(4,1) = (2*xi-1)*eta*(1+eta)/4;
dPsi(5,1) = xi*eta*(1-eta);
dPsi(6,1) = (1+2*xi)*(1-eta*eta)/2;
dPsi(7,1) = -xi*eta*(1+eta);
dPsi(8,1) = (2*xi-1)*(1-eta*eta)/2;
dPsi(9,1) = -2*xi*(1-eta*eta);
%
dPsi(1,2) = xi*(1-xi)*(1-2*eta)/4;
dPsi(2,2) = xi*(1+xi)*(2*eta-1)/4;
dPsi(3,2) = xi*(1+xi)*(2*eta+1)/4;
dPsi(4,2) = xi*(xi-1)*(2*eta+1)/4;
dPsi(5,2) = (1-xi*xi)*(2*eta-1)/2;
dPsi(6,2) = -xi*(1+xi)*eta;
dPsi(7,2) = (1-xi*xi)*(2*eta+1)/2;
dPsi(8,2) = xi*(1-xi)*eta;
dPsi(9,2) = -2*eta*(1-xi*xi);

% Clculo do Jacobiano
J = points*dPsi;

% Clculo das derivadas parciais em x e y.
B = dPsi/J;
% B = dPsi*inv(J);
end