%% Clculo da matriz de derivadas parciais e jacobiano

function [B, J, psi] = calculoBTri6(points,xi,eta)

psi(1) = (1-xi-eta)*(1-2*xi-2*eta);
psi(2) = xi*(2*xi-1);
psi(3) = eta*(2*eta-1);
psi(4) = 4*(1-xi-eta)*xi;
psi(5) = 4*xi*eta;
psi(6) = 4*(1-xi-eta)*eta;

dPsi(1,1) = 4*xi+4*eta-3;
dPsi(2,1) = 4*xi-1;
dPsi(3,1) = 0;
dPsi(4,1) = 4 -8*xi -4*eta;
dPsi(5,1) = 4*eta;
dPsi(6,1) = -4*eta;
%
dPsi(1,2) = 4*xi+4*eta-3;
dPsi(2,2) = 0;
dPsi(3,2) = 4*eta-1;
dPsi(4,2) = -4*xi;
dPsi(5,2) = 4*xi;
dPsi(6,2) = 4 -4*xi -8*eta;

% Clculo do Jacobiano
J = points*dPsi;

% Clculo das derivadas parciais em x e y.
B = dPsi/J;
% B = dPsi*inv(J);

end